#include <bits/stdc++.h>

using namespace std;

struct query {
	int type;
	int i, l, r, m, d;
	query() {}
	query( int _i, int _m, int _d ) {
		type = 1;
		i = _i;
		m = _m;
		d = _d;
	}
	query( int _l, int _r ) {
		type = 2;
		l = _l;
		r = _r;
	}
	void write() {
		cout << type << " ";
		if( type == 1 )
			cout << i << " " << m << " " << d << endl;
		else
			cout << l << " " << r << endl;
	}
};

int test;
int minN, maxN;
int q;
int type;
int p;
int minM, maxM;
int minD, maxD;
int dist;
int n;

void getParams( int argc, char *argv[] ) {
	test = atol( argv[1] );
	minN = atol( argv[2] );
	maxN = atol( argv[3] );
	q = atol( argv[4] );
	type = atol( argv[5] );
	p = atol( argv[6] );
	minM = atol( argv[7] );
	maxM = atol( argv[8] );
	minD = atol( argv[9] );
	maxD = atol( argv[10] );
	dist = atol( argv[11] );
}

void readParams() {
	cin >> test;
	cin >> minN >> maxN;
	cin >> q;
	cin >> type;
	cin >> p;
	cin >> minM >> maxM;
	cin >> minD >> maxD;
	cin >> dist;
}

void writeTest( int n, int q, vector< query > &v ) {
	cout << n << " " << q << endl;
	for( int i = 0; i < q; i ++ ) {
		v[i].write();
	}
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

query genQuery1() {
	int i = randNumber( 1, n );
	int m = randNumber( minM, maxM );
	int d = randNumber( minD, maxD );
	d = min( d, m );
	return query( i, m, d );
}

query genQuery2() {
	int l = randNumber( 1, n - dist );
	int r = randNumber( l + dist, n );
	return query( l, r );
}

int main( int argc, char *argv[] ) {
	getParams( argc, argv );
	//readParams();

	srand( test + minN + maxN + q + type + p + minM + maxM + minD + maxD + dist );

	n = randNumber( minN, maxN );
	
	if( dist >= n )
		dist = n - randNumber( 1, 10 );
	dist = max( dist, 0 );
	
	vector< query > v;

	if( type == 1 ) {
		for( int i = 0; i < q; i ++ ) {
			if( randNumber( 1, 100 ) > p && i != q-1 )
				v.push_back( genQuery1() );
			else
				v.push_back( genQuery2() );
		}
	} else if( type == 2 ) {
		for( int i = 0; i < q; i ++ ) {
			if( ( i & 1 ) || i == q-1 )
				v.push_back( genQuery2() );
			else
				v.push_back( genQuery1() );
		}
	} else if( type == 3 ) {
		for( int i = 0; i < q-1; i ++ ) {
			v.push_back( genQuery1() );
		}
		v.push_back( genQuery2() );
	} else if( type == 4 ) {
		v.push_back( genQuery1() );
		for( int i = 0; i < q-1; i ++ ) {
			v.push_back( genQuery2() );
		}
	} else if( type == 5 ) {
		for( int i = 0; i < q / 2; i ++ ) {
			v.push_back( genQuery1() );
		}
		for( int i = q / 2; i < q; i ++ ) {
			v.push_back( genQuery2() );
		}
	}
	writeTest( n, q, v );
    return 0;
}


