#include <bits/stdc++.h>

using namespace std;

int N = 316;

int l[333];
int r[333];
int M[333];
int D[333];
long long sum[333];

long long a[111111];
int I[111111];

long long getSum( int l, int r, int L, int R ) {
	int cnt = R - L + 1;
	return ( l + r ) * 1LL * cnt / 2;
}

int update( int i ) {
	for( int j = l[i]; j <= r[i]; j ++ ) {
		a[j] += M[i];
		M[i] -= D[i];
	}
	M[i] = 0;
	D[i] = 0;
}

void add( int i, int m, int d ) {
	int j = I[i];
	update( j );
	for( int k = i, M = m; k >= l[j] && M > 0; k --, M -= d ) {
		a[k] += M;
		sum[j] += M;
	}
	for( int k = i + 1, M = m - d; k <= r[j] && M > 0; k ++, M -= d ) {
		a[k] += M;
		sum[j] += M;
	}
	for( int k = j - 1; k >= 0; k -- ) {
		int sl = m - d * abs( i - l[k] );
		int sr = m - d * abs( i - r[k] );
		if( sl <= 0 ) {
			update( k );
			for( int i = r[k], M = sr; i >= l[k] && M > 0; i --, M -= d ) {
				a[i] += M;
				sum[k] += M;
			}
			break;
		}
		M[k] += sl;
		D[k] -= d;
		sum[k] += getSum( sl, sr, l[k], r[k] );
	}
	for( int k = j + 1; k < 333; k ++ ) {
		int sl = m - d * abs( i - l[k] );
		int sr = m - d * abs( i - r[k] );
		if( sr <= 0 ) {
			update( k );
			for( int i = l[k], M = sl; i <= r[k] && M > 0; i ++, M -= d ) {
				a[i] += M;
				sum[k] += M;
			}
			break;
		}
		M[k] += sl;
		D[k] += d;
		sum[k] += getSum( sl, sr, l[k], r[k] );
	}
}

long long get( int L, int R ) {
	int i = I[L];
	int j = I[R];
	update( i );
	update( j );
	long long ans = 0;
	if( i == j ) {
		for( int k = L; k <= R; k ++ ) {
			ans += a[k];
		}
		return ans;
	}
	for( int k = L; k <= r[i]; k ++ ) {
		ans += a[k];
	}
	for( int k = R; k >= l[j]; k -- ) {
		ans += a[k];
	}
	for( int k = i + 1; k < j; k ++ ) {
		ans += sum[k];
	}
	return ans;
}

int main() {
	int n, q;
	cin >> n >> q;
	for( int i = 0; i < 333; i ++ ) {
		l[i] = i * N + 1;
		r[i] = i * N + N;
		for( int j = l[i]; j <= r[i]; j ++ ) {
			I[j] = i;
		}
	}
	for( int i = 0; i < q; i ++ ) {
		int t;
		cin >> t;
		if( t == 1 ) {
			int i, m, d;
			cin >> i >> m >> d;
			add( i, m, d );
		} else {
			int l, r;
			cin >> l >> r;
			cout << get( l, r ) << endl;
		}
	}
    return 0;
}
